// This is the main DLL file.

#include "stdafx.h"
#include "MessageHook.h"

#include "dbghelp.h"

using namespace System;
using namespace System::ComponentModel;

#pragma warning(disable: 4793)  // asm block causes native code generation

namespace MessageHook {

// A relative jump to this function is patched into the real 
// messagebox function in user32.dll.
int __stdcall _MessageBoxEx(HWND hwnd, LPCWSTR lpText, LPCWSTR lpCaption, UINT uType, WORD /* wLanguageId */)
{
	MessageBoxInfo^ mbi = gcnew MessageBoxInfo(hwnd, lpText, lpCaption, uType);
	return static_cast<int>(HookMonkey::s_handler(mbi));
}

void FailIf(BOOL fail)
{
	if(fail)
		throw gcnew Win32Exception();
}

// This overwrites the first few bytes of user32!MessageBoxExW with
// a relative branch to our hook.
void InstallHook()
{
	HMODULE hUser32 = LoadLibrary(L"user32.dll");
	PROC pMsgBox = GetProcAddress(hUser32, "MessageBoxExW");
	FailIf(pMsgBox == NULL);

	// Need to change the memory protection for the (read/execute) page 
	// in user32.dll before we write to it.
	MEMORY_BASIC_INFORMATION mbi = {0};
	VirtualQuery(pMsgBox, &mbi, sizeof(MEMORY_BASIC_INFORMATION));
	FailIf(!VirtualProtect(mbi.BaseAddress, mbi.RegionSize, PAGE_READWRITE, &mbi.Protect));

	// Copy in the jump instruction 
	__asm 
	{
		mov edi, pMsgBox;				// edi <- user32!MessageBoxExW
		mov byte ptr [edi], 0xe9;		// write the opcode for JMP rel32

		mov eax, offset _MessageBoxEx;	// eax <- relative offs of our function
		sub eax, edi;					// eax <- (offset _MessageBoxEx) - user32!MessageBoxExW
		sub eax, 5;						// one byte for jmp, four for the address
		
		inc edi;						// copy in the address
		stosd;
	};

	// Restore the old protection 
	DWORD oldProtect = 0;
	FailIf(!VirtualProtect(mbi.BaseAddress, mbi.RegionSize, mbi.Protect, &oldProtect));
}

void HookMonkey::Install(handler_t handler)
{
	HookMonkey::s_handler = handler;	
	InstallHook();
}

}